"""Reddit databaes models."""
from datetime import datetime, timezone
from functools import partial

from beanie import Document, Field


def get_now() -> datetime:
    """Get proper timestamp."""
    return datetime.now(tz=timezone.utc)


NowField = partial(Field, default_factory=get_now)


class Subreddit(Document):
    """Subreddit object."""

    display_name: str
    over18: bool = False


class SubredditFollow(Document):
    """Subreddit Follow object."""

    active: bool = True
    display_name: str
    channel: int
    guild: int
    admin: int
    created_at: datetime = NowField()

    class Setting:
        name = "subredditfollow"
